;Legacy Exception Table
	dc.l	$01000000,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	dc.l	$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	dc.l	$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	dc.l	$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	dc.l	$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	dc.l	$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	dc.l	$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	dc.l	$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0,$000003F0
	
	
;Genesis Header
	DC.B	"SEGA GENESIS    "	;System Name
	DC.B	"(C)CHBI "			;Copyright
 	DC.B	"2022.JUN"			;Date
	DC.B	"ChibiAkumas.com 32X                             " ; Cart Name
	DC.B	"ChibiAkumas.com 32X                             " ; Cart Name (Alt)
	DC.B	"GM CHIBI001-00"	;TT NNNNNNNN-RR T=Type (GM=Game) N=game Num  R=Revision
	DC.W	$0000				;16-bit Checksum (Address $000200+)
	DC.B	"J               "	;Control Data (J=3button K=Keyboard 6=6button C=cdrom)
	DC.L	$00000000			;ROM Start
	DC.L	$003FFFFF			;ROM Length
	dc.l	$00E00000,$00FFFFFF
	dc.b	"                "
	dc.b	"                "
	dc.b	"                "
	dc.b	"                "
	dc.b	"JUE             "

	
;New Exception Table
	org $200		;Reset Code
	jmp	ProgStart
	rte
	org $206		;Bus Error
	rte
	org $20C		;Address Error
	rte
	org $212		;Illegal Instruction
	rte
	org $218		;Divide by 0
	rte
	org $21E		;CHK Instruction
	rte
	org $224		;TRAPV Instruction
	rte
	org $22A		;Privilege Violation
	rte
	org $230		;Trace
	rte
	org $236		;Line 1010 Emulator
	rte
	org $23C		;Line 1111 Emulator
	rte
	org $242		;RESERVED (Can actually be anything)
	rte
	org $248		;RESERVED (Can actually be anything)
	rte
	org $24E		;RESERVED (Can actually be anything)
	rte
	org $254		;RESERVED (Can actually be anything)
	rte
	org $25A		;RESERVED (Can actually be anything)
	rte
	org $260		;RESERVED (Can actually be anything)
	rte
	org $266		;RESERVED (Can actually be anything)
	rte
	org $26C		;RESERVED (Can actually be anything)
	rte
	org $272		;RESERVED (Can actually be anything)
	rte
	org $278		;RESERVED (Can actually be anything)
	rte
	org $27E		;RESERVED (Can actually be anything)
	rte
	org $284		;RESERVED (Can actually be anything)
	rte
	org $28A		;Spurious Interrupt
	rte
	org $290		;Level 1 Interrupt
	rte
	org $296		;Level 2 Interrupt (TH)
	rte
	org $29C		;Level 3 Interrupt
	rte
	org $2A2		;Level 4 Interrupt (H-Blank)
	rte
	org $2A8		;Level 5 Interrupt
	rte
	org $2AE		;Level 6 Interrupt (V-Blank)
	rte
	org $2B4		;Level 7 Interrupt
	rte
	org $2BA		;Trap #0 Instruction
	rte
	org $2C0		;Trap #1 Instruction
	rte
	org $2C6		;Trap #2 Instruction
	rte
	org $2CC		;Trap #3 Instruction
	rte
	org $2D2		;Trap #4 Instruction
	rte
	org $2D8		;Trap #5 Instruction
	rte
	org $2DE		;Trap #6 Instruction
	rte
	org $2E4		;Trap #7 Instruction
	rte
	org $2EA		;Trap #8 Instruction
	rte
	org $2F0		;Trap #9 Instruction
	rte
	org $2F6		;Trap #10 Instruction
	rte
	org $2FC		;Trap #11 Instruction
	rte
	org $302		;Trap #12 Instruction
	rte
	org $308		;Trap #13 Instruction
	rte
	org $30E		;Trap #14 Instruction
	rte
	org $314		;Trap #15 Instruction
	rte
	
	org $3C0 ;32x Header (Mars User Header)
	dc.b    "MARS CHECK MODE "	;3C0: Module name
	dc.l 	0					;3D0: Version
	dc.l	My32xProgram	;3D4: 32X Source address
	dc.l	$00000000		;3D8: 32x Destination address (0x06000000 base)
	dc.l	$10000			;3DC: 32x Program Length (bytes)
	
	dc.l	$06000004		;3E0: Primary SH2 Exec address
	dc.l	$06000000		;3E4: Secondary SH2 Exec address
	
	dc.l	$00000000		;3E8: Primary Vector Base Register (VBR) Address
	dc.l	$00000000		;3EC: Secondary Vector Base Register (VBR) Address
	
	

	org $3F0	;32x Startup
	move.l	#$FFFFFFC0,a4		;$287C,$FFFF,$FFC0
	move.l	#$00000000,($A15128);$23FC,$0000,$0000,$00A1,$5128
	
	
	org $400 ;Secret code! (32x Security)
	
	dc.w	$46FC,$2700,$4BF9,$00A1,$0000,$7001,$0CAD,$4D41
	dc.w	$5253,$30EC,$6600,$03E6,$082D,$0007,$5101,$67F8
	dc.w	$4AAD,$0008,$6710,$4A6D,$000C,$670A,$082D,$0000
	dc.w	$5101,$6600,$03B8,$102D,$0001,$0200,$000F,$6706
	dc.w	$2B78,$055A,$4000,$7200,$2C41,$4E66,$41F9,$0000
	dc.w	$04D4,$6100,$0152,$6100,$0176,$47F9,$0000,$04E8
	dc.w	$43F9,$00A0,$0000,$45F9,$00C0,$0011,$3E3C,$0100
	dc.w	$7000,$3B47,$1100,$3B47,$1200,$012D,$1100,$66FA
	dc.w	$7425,$12DB,$51CA,$FFFC,$3B40,$1200,$3B40,$1100
	dc.w	$3B47,$1200,$149B,$149B,$149B,$149B,$41F9,$0000
	dc.w	$04C0,$43F9,$00FF,$0000,$22D8,$22D8,$22D8,$22D8
	dc.w	$22D8,$22D8,$22D8,$22D8,$41F9,$00FF,$0000,$4ED0
	dc.w	$1B7C,$0001,$5101,$41F9,$0000,$06BC,$D1FC,$0088
	dc.w	$0000,$4ED0,$0404,$303C,$076C,$0000,$0000,$FF00
	dc.w	$8137,$0002,$0100,$0000,$AF01,$D91F,$1127,$0021
	dc.w	$2600,$F977,$EDB0,$DDE1,$FDE1,$ED47,$ED4F,$D1E1
	dc.w	$F108,$D9C1,$D1E1,$F1F9,$F3ED,$5636,$E9E9,$9FBF
	dc.w	$DFFF,$4D41,$5253,$2049,$6E69,$7469,$616C,$2026
	dc.w	$2053,$6563,$7572,$6974,$7920,$5072,$6F67,$7261
	dc.w	$6D20,$2020,$2020,$2020,$2020,$2043,$6172,$7472
	dc.w	$6964,$6765,$2056,$6572,$7369,$6F6E,$2020,$2020
	dc.w	$436F,$7079,$7269,$6768,$7420,$5345,$4741,$2045
	dc.w	$4E54,$4552,$5052,$4953,$4553,$2C4C,$5444,$2E20
	dc.w	$3139,$3934,$2020,$2020,$2020,$2020,$2020,$2020
	dc.w	$2020,$2020,$2020,$2020,$2020,$2020,$2020,$2020
	dc.w	$2020,$2020,$2020,$524F,$4D20,$5665,$7273,$696F
	dc.w	$6E20,$312E,$3000,$48E7,$C040,$43F9,$00C0,$0004
	dc.w	$3011,$303C,$8000,$323C,$0100,$3E3C,$0012,$1018
	dc.w	$3280,$D041,$51CF,$FFF8,$4CDF,$0203,$4E75,$48E7
	dc.w	$81C0,$41F9,$0000,$063E,$43F9,$00C0,$0004,$3298
	dc.w	$3298,$3298,$3298,$3298,$3298,$3298,$2298,$3341
	dc.w	$FFFC,$3011,$0800,$0001,$66F8,$3298,$3298,$7000
	dc.w	$22BC,$C000,$0000,$7E0F,$3340,$FFFC,$3340,$FFFC
	dc.w	$3340,$FFFC,$3340,$FFFC,$51CF,$FFEE,$22BC,$4000
	dc.w	$0010,$7E09,$3340,$FFFC,$3340,$FFFC,$3340,$FFFC
	dc.w	$3340,$FFFC,$51CF,$FFEE,$4CDF,$0381,$4E75,$8114
	dc.w	$8F01,$93FF,$94FF,$9500,$9600,$9780,$4000,$0080
	dc.w	$8104,$8F02,$48E7,$C140,$43F9,$00A1,$5180,$08A9
	dc.w	$0007,$FF80,$66F8,$3E3C,$00FF,$7000,$7200,$337C
	dc.w	$00FF,$0004,$3341,$0006,$3340,$0008,$4E71,$0829
	dc.w	$0001,$000B,$66F8,$0641,$0100,$51CF,$FFE8,$4CDF
	dc.w	$0283,$4E75,$48E7,$8180,$41F9,$00A1,$5200,$08A8
	dc.w	$0007,$FF00,$66F8,$3E3C,$001F,$20C0,$20C0,$20C0
	dc.w	$20C0,$51CF,$FFF6,$4CDF,$0181,$4E75,$41F9,$00FF
	dc.w	$0000,$3E3C,$07FF,$7000,$20C0,$20C0,$20C0,$20C0
	dc.w	$20C0,$20C0,$20C0,$20C0,$51CF,$FFEE,$3B7C,$0000
	dc.w	$1200,$7E0A,$51CF,$FFFE,$43F9,$00A1,$5100,$7000
	dc.w	$2340,$0020,$2340,$0024,$1B7C,$0003,$5101,$2E79
	dc.w	$0088,$0000,$0891,$0007,$66FA,$7000,$3340,$0002
	dc.w	$3340,$0004,$3340,$0006,$2340,$0008,$2340,$000C
	dc.w	$3340,$0010,$3340,$0030,$3340,$0032,$3340,$0038
	dc.w	$3340,$0080,$3340,$0082,$08A9,$0000,$008B,$66F8
	dc.w	$6100,$FF12,$08E9,$0000,$008B,$67F8,$6100,$FF06
	dc.w	$08A9,$0000,$008B,$6100,$FF3C,$303C,$0040,$2229
	dc.w	$0020,$0C81,$5351,$4552,$6700,$0092,$303C,$0080
	dc.w	$2229,$0020,$0C81,$5344,$4552,$6700,$0080,$21FC
	dc.w	$0088,$02A2,$0070,$303C,$0002,$7200,$122D,$0001
	dc.w	$1429,$0080,$E14A,$8242,$0801,$000F,$660A,$0801
	dc.w	$0006,$6700,$0058,$6008,$0801,$0006,$6600,$004E
	dc.w	$7020,$41F9,$0088,$0000,$3C28,$018E,$4A46,$6700
	dc.w	$0010,$3429,$0028,$0C42,$0000,$67F6,$B446,$662C
	dc.w	$7000,$2340,$0028,$2340,$002C,$3E14,$2C7C,$FFFF
	dc.w	$FFC0,$4CD6,$7FF9,$44FC,$0000,$6014,$43F9,$00A1
	dc.w	$5100,$3340,$0006,$303C,$8000,$6004,$44FC,$0001

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	
ProgStart:		;Start of our program on the genesis side

ReleaseVDP:
	move.w	$A15100,d0
	or.w	#$8000,d0		;Release VDP to SH2
	move.w	d0,$A15100

WaitForSh2:	
	move.l ($A15120),d0
	cmp.l #$66606601,d0
	bne WaitForSh2
	
InfLoop:	
	jsr Player_ReadControlsDual

	move.w d0,($A15120)		;A15120-A1512E arL shared regs
	move.w d1,($A15122)		;2000402022000402E2000402E on SH2
	
	move.w $A15124,d0
	jsr ChibiSound
	
	move.l #$1000,d0		;Joystick malfunctions if we read it too fast
Pause:	
	dbra d0,Pause
	
	
	jmp	InfLoop				;68000 loop

	
Player_ReadControlsDual:		;D0=1up D1=2up ---7654S321RLDU
	
	move.b #%01000000,($A1000B)	; Set direction IOIIIIII (I=In O=Out)
	move.l #$A10005,a0			;RW port for player 2
	jsr Player_ReadOne			;Read buttons
	
	move.l d0,-(sp)
		move.b #%01000000,($A10009)	; Set direction IOIIIIII (I=In O=Out)
		move.l #$A10003,a0		;RW port for player 1
		jsr Player_ReadOne		;Read buttons
	move.l (sp)+,d1
	rts
	
Player_ReadOne:			;Read in and reformat a players buttons
	
	move.b  #$40,(a0)	; TH = 1
	nop		;Delay
	nop
	move.b  (a0),d2		; d0.b = --CBRLDU	Store in D2
	
	move.b	#$0,(a0)	; TH = 0
	nop		;Delay
	nop
	move.b	(a0),d1		; d1.b = --SA--DU	Store in D1
	
	move.b  #$40,(a0)	; TH = 1
	nop		;Delay
	nop
	move.b	#$0,(a0)	; TH = 0
	nop		;Delay
	nop
	move.b  #$40,(a0)	; TH = 1
	nop		;Delay
	nop
	move.b	(a0),d3		; d1.b = --CBXYZM	Store in D3
	nop		;Delay
	nop
	move.b	#$0,(a0)	; TH = 0
	
	clr.l d0			;Clear buildup byte
	roxr.b d2
	roxr.b d0			;U
	roxr.b d2
	roxr.b d0			;D
	roxr.b d2
	roxr.b d0			;L
	roxr.b d2
	roxr.b d0			;R
	roxr.b #5,d1
	roxr.b d0			;A
	roxr.b d2
	roxr.b d0			;B
	roxr.b d2
	roxr.b d0			;C
	roxr.b d1
	roxr.b d0			;S
	
	move.l d3,d1
	roxl.l #7,d1		;XYZ
	and.l #%0000011100000000,d1
	or.l d1,d0			
	
	move.l d3,d1
	roxl.l #8,d1		;M
	roxl.l #3,d1		
	and.l #%0000100000000000,d1
	or.l d1,d0
	
	or.l #$FFFFF000,d0	;Set unused bits to 1
	rts
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	

ChibiSound:					;NVTTTTTT	Noise Volume Tone 
	and.l #$000000FF,d0
	tst.b d0				;See if d0=0
	beq silent
	
	move.b d0,d3		  
			;1CCTLLLL	(Latch - Channel Type DataL
	move.b #%11001111,$C00011

	and.b  #%00111111,d0		;Get Tone H
	move.b d0,$C00011

	move.b d3,d0
	and.b #%01000000,d0			;Volume bit
	ror.b #4,d0
	move.b d0,d2				;backup for noise
	eor.b #%11010100,d0 
	move.b d0,$C00011			;Set Volume

			;1CCTVVVV	(Latch - Channel Type Volume)	
	move.b #%11111111,$C00011

	btst #7,d3			
	beq ChibiSoundNoNoise	
	
	move.b d3,d0				;Noise Generator seems to be different on Genesis compared to others!
	and.b #%00000111,d0			;Slowest noise is too slow!
	rol #1,d0
	or.b  #%11000001,d0			;Low Noise Freq
	move.b d0,$C00011
	
	move.b d3,d0
	and.b #%00111000,d0
	ror #3,d0
	move.b d0,$C00011			;High Noise Freq
	
			;1CCTVVVV	(Latch - Channel Type Volume)	
	move.b #%11011111,$C00011	;Mute Tone
	move.b #%11100111,$C00011	;Enable Noise (White - linked to channel 2)
	
	move.b d2,d0				;Noise volume
	eor.b #%11110100,d0 
	move.b d0,$C00011			;Set Volume
ChibiSoundNoNoise:
	rts

silent:		;Mute Nosie and Tone (Vol 15=mute)
			;1CCTVVVV
	move.b #%11111111,$C00011	;(Latch - Channel Type Volume)	
	move.b #%11011111,$C00011	;(Latch - Channel Type Volume)	
	rts
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	


	even
My32xProgram:		;32x ROM needs to be appended here