
	org $06000000
	
;Cpu 2 Entry - $06000000 - Secondary SH2 Exec address
Cpu2Loop:					;CPU2=Slave CPU CPU1=Master CPU
	bra	Cpu2Loop
	nop		
	

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			
	
;Cpu 1 Entry - $06000004 - Primary SH2 Exec address
Cpu1_ProgStart:				
	mov.l #$20004000,r2		;$20004000 	Interrupt mask	%F-----ACH---VHCP
							;  F=Vdp access (0=MD 1=SH2) A=Adapter enable (1=32x on) 
							;  C=Cart in?(1=no) H=H-int(1=on) C=Command int on
							;  P=PWM timer interrupt
Waitfor68k:
	mov.w @r2,r1			;MSH2_WW_IntC		Bus Controller
	exts.w r1,r1
	cmp/pz r1				;Bit 15=1 means SH2 has VDP
	bt Waitfor68k

;Turn on the screen
	
	mov.l #$20004100,r1	;$20004100  Bitmap Mode Register
	mov	#1,r2			;  %P-------pL----MM  P=Pal/Ntcs p+priorty(1=32x)
						;  L=240 line?  M=screen mode (pixel format)
	mov.w r2,@r1		;    Packed pixel Mode (8bpp palette)
	
;Define line tablee
	
	bsr DoLineTable			;Define Line table 1
	nop
	bsr PageFlip			;Flip Buffer
	nop
	bsr DoLineTable			;Define Line table 2
	nop
	
;Set up our palette	
	
	mov.l #$20004200,r6		;$20004200 - VDP CRAM (512 bytes)
	mov.l #Palette,r8		;Palette
	mov	#4,r0				;PaletteEntries
PaletteLoop:
	mov.w @r8+,r1			;-BBBBBGGGGGRRRRR
	mov.w r1,@r6			;Set a color
	add	#2,r6
	
	dt r0					;Dec R0
	bf PaletteLoop 
	
;Zero cursor pos
		
	mov.l #UserRam,r14		;Pointer to our work ram
	mov #0,r0				;Set the cursor pos to 0,0
	
	mov.l r0,@(UserRam_CursorX,r14)
	mov.l r0,@(UserRam_CursorY,r14)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;Show our message!	
	
	mov.l #TxtHelloWorld,r13
	bsr PrintString			;Show string R13
	nop						;NOP in the BSR delay slot
	
	bsr PageFlip			;Show the graphics to screen
	nop						;NOP in the BSR delay slot
	
InfLoop:	
	bra	InfLoop				;Branch to INFLOOP
	nop						;NOP in the BRA delay slot

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
PrintString:	;Print String R13
	sts.l pr,@-sp			;Backup return address
PrintStringAgain:		
		mov.b @r13+,r0		;Get a char into R0
		mov #-1,r1			;Compare to 255
		cmp/eq r0,r1
		bt PrintStringDone	;Done? return!
		nop		
		bsr PrintChar		;Print char R0
		nop
		bra PrintStringAgain ;Repeat
		nop
PrintStringDone:
	lds.l @sp+,pr			;Restore return address
	rts
	nop
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
PrintChar:	;PrintChar R0
	sts.l mach,@-sp				;Back up used registers
	sts.l macl,@-sp		
	mov.l r0,@-sp
	mov.l r1,@-sp
	mov.l r2,@-sp
	mov.l r3,@-sp
	mov.l r4,@-sp
	mov.l r5,@-sp
	mov.l r6,@-sp
	
		mov.l #Font,r5
		add #-32,r0				;No Char below space
		shll r0
		shll r0
		shll r0					;8 bytes per char
		add r0,r5				;R5=Font source.
		
		
		mov.l #$24000200,r6		;Frame Buffer VRAM
		mov.l #UserRam,r4		;R4 points to our work ram

		mov.l @(UserRam_CursorX,r4),r0
		shll r0
		shll r0
		shll r0					;8 bytes per Horiz char
		add r0,r6
				
		mov.l @(UserRam_CursorY,r4),r0
		shll r0
		shll r0
		shll r0					;8 lines per vert char
		mov.l #320,r1			;320 bytes per line
		mulu r0,r1
		sts macl,r0				;Get L result of multiplication
		add r0,r6				;Add Y offset
		
		
		mov #7,r1				;Move 7 pixels right (work right->left)
		add r1,r6				
		
		mov #8,r1				;Y Lines
NextYLine:	
		mov #8,r0				;Bits per line
		mov.b @r5+,r3			;Get a byte
NextXPixel:
		mov #1,r2				;Fill pixel
		
		rotcr r3				;Get a bit
		bt CharPixelSet
		mov #0,r2				;Clear pixel
CharPixelSet:		
		mov.b r2,@r6			;Write pixel
		add #-1,r6				;Left one pixel
		dt r0					;Decrease X count
		bf NextXPixel			;Repeat for next pixel
		
		mov.l #320+8,r0			;One line = 320 bytes + 8 pixels drawn
		add r0,r6				;Down a line
		dt r1					;Decrease Y count
		bf NextYLine			;Repeat for next line
				
		mov.l @(UserRam_CursorX,r4),r0
		add #1,r0				;Across one char
		mov.l r0,@(UserRam_CursorX,r4)
		
		
	mov.l @sp+,r6				;Restore the registers.
	mov.l @sp+,r5
	mov.l @sp+,r4
	mov.l @sp+,r3
	mov.l @sp+,r2
	mov.l @sp+,r1
	mov.l @sp+,r0
	lds.l @sp+,macl
	lds.l @sp+,mach
	rts							;Return from subroutine
	nop							;NOP in delay slot of RTS
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
DoLineTable:	
	mov.l #$24000000,r6   ;Frame Buffer
	mov.l #$100,r8	 	;LineStartAddr - Addr in pairs of bytes 
						; (Actual addr /2) $[2400]0200/2=$100
	mov.l #224,r0 		;Line Count
	mov.l #160,r7		;Length of line in pairs of bytes (320/2)

LineTableLoop:	
	mov.w r8,@r6	;Define line address
	add r7,r8		;Move down one line
	add	#2,r6		;Next Line table address
	
	add #-1,r0
	cmp/eq #0,r0
	bf LineTableLoop
	rts	
	nop
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

PageFlip:
	mov.l #UserRam,r14		;R14 points to our work ram
	mov.l @(UserRam_VdpStat,r14),r1	;Get framebuffer state
	mov	r1,r0
	
	mov.l #$2000410A,r2	;$2000410A Frame Buffer control reg
						;  %VHP-----------FS  V=Vblank H=Hblank 
						;     P=Palette accessable F=frame buffer accessible
						;     S=Swap vram to VDP

	xor	#1,r0				;Flip frame buffer
	mov.l r0,@(UserRam_VdpStat,r14)	;Save in ram
	mov.w r0,@r2			;Update VDP reg
	
WaitForFlip:	
	mov.w @r2,r0
	and	#1,r0				;Buffer State
	cmp/eq r1,r0			;Has buffer flipped? (only flips in vblank)
	bt WaitForFlip			;NO! Then Wait!!!
	rts	
	nop
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
	align 4						;Ensure we're still 32 bit aligned!

	ltorg
	
TxtHelloWorld: dc.b "Hello World 12345 !?",255
	
Font:							;1bpp font - 8x8 96 characters 
	binclude "\ResALL\Font96.FNT"

	align 4						;Ensure we're still 32 bit aligned!

	
Palette:
		;%-BBBBBGGGGGRRRRR
	dc.w %0011110000000000		;Our 4 colors!
	dc.w %0000001111111111
	dc.w %0111111111100000
	dc.w %0000000000011111
	     
UserRam_VdpStat equ 0	
UserRam_CursorX equ 4
UserRam_CursorY equ 8
	
UserRam:	ds.l 8				;Define 8 32bit longs 