

	org $6004000 		;Base address for a BIN file
	
	
;Set up the VDP2 registers
	mov.l #$25f80000,r11	;VDP2_Regs
	add #$E,r11				
		  ;%C-cc--VVRRRRRRRR cc=0=5bit RGB
	mov.w #%1000001111111111,r6 ;Set ram partitioning / screen mode
	mov.w r6,@r11		;$25f8000E RAMCTL - Ram Control Register

	add #$2e,r11		
		;%-NNN-nnn-NNN-nnn
	mov	#%0000000000000000,r2		
	mov.w r2,@r11		;$25f8003C MPOFN - Map Offset Register
	
	add #$3c,r11	
		;%NNNNNNNN--------
	mov.w r2,@-r11		;$25f80076 - SCYDN0 Scr Scroll (Vert Fraction)
	
		;%-----NNNNNNNNNNN
	mov.w r2,@-r11		;$25f80074 - SCYIN0 Scr Scroll (Vert Integer)
	
		;%NNNNNNNN--------
	mov.w r2,@-r11		;$25f80072 - SCXDN0 Scr Scroll (Horiz Fraction)
	
		;%-----NNNNNNNNNNN
	mov.w r2,@-r11		;$25f80070 - SCXIN0 Scr Scroll (Horiz Integer)
	
	add #-72,r11		
	      ;%--CCNNES-cccnnes c=colors (16/256/2k/32k/16m)  e=1=bmp format
	mov.w #%0000000000010010,r2	;nn=bmp size(512x256/512x512/1024x256/1024x512)
	mov.w r2,@r11		;$25f80028 CHCTLA - Character ctrl (NBG0, NBG1)
	
	 
	add	#-8,r11	
		  ;%---RNNNN--rrnnnn RN=Transparency / rn=enabled
	mov.w #%0000000100000001,r8
	mov.w r8,@r11		;$25f80020 BGON - Screen Display Enable
	
	add	#-32,r11	
		 ; %D------BLLVV-HHH	D=1=Screen on B=1=Blackout 
	mov.l #%1000000000000000,r10	;L=interlace H=Hres V=Vres
	mov.w r10,@r11		;$25f80000 TVMD - TV Mode
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;Set Palette
	mov.l #$25F00000,r6		;VDP2_CRAM
	mov.l #Palette,r8		;Palette
	mov	#4,r0				;PaletteEntries
PaletteLoop:
	mov.w @r8+,r1			;-BBBBBGGGGGRRRRR
	mov.w r1,@r6			;Set a color
	add	#2,r6
	
	dt r0					;Dec R0
	bf PaletteLoop 
	
	
	
	mov.l #UserRam,r14		;Pointer to our work ram
	mov #0,r0				;Set the cursor pos to 0,0
	
	mov.l r0,@(UserRam_CursorX,r14)
	mov.l r0,@(UserRam_CursorY,r14)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
	mov.l #TxtHelloWorld,r13
	bsr PrintString			;Show string R13
	nop						;NOP in the BSR delay slot
	
InfLoop:	
	bra	InfLoop				;Branch to INFLOOP
	nop						;NOP in the BRA delay slot

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
PrintString:	;Print String R13
	sts.l pr,@-sp			;Backup return address
PrintStringAgain:		
		mov.b @r13+,r0		;Get a char into R0
		mov #-1,r1			;Compare to 255
		cmp/eq r0,r1
		bt PrintStringDone	;Done? return!
		nop		
		bsr PrintChar		;Print char R0
		nop
		bra PrintStringAgain ;Repeat
		nop
PrintStringDone:
	lds.l @sp+,pr			;Restore return address
	rts
	nop
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
PrintChar:	;PrintChar R0
	sts.l mach,@-sp				;Back up used registers
	sts.l macl,@-sp		
	mov.l r0,@-sp
	mov.l r1,@-sp
	mov.l r2,@-sp
	mov.l r3,@-sp
	mov.l r4,@-sp
	mov.l r5,@-sp
	mov.l r6,@-sp
	
		mov.l #Font,r5
		add #-32,r0				;No Char below space
		shll r0
		shll r0
		shll r0					;8 bytes per char
		add r0,r5				;R5=Font source.
		
		
		mov.l #$25e00000,r6		;Screen VRAM
		mov.l #UserRam,r4		;R4 points to our work ram

		mov.l @(UserRam_CursorX,r4),r0
		shll r0
		shll r0
		shll r0					;8 bytes per Horiz char
		add r0,r6
				
		mov.l @(UserRam_CursorY,r4),r0
		shll r0
		shll r0
		shll r0					;8 lines per vert char
		mov.l #512,r1			;512 bytes per line
		mulu r0,r1
		sts macl,r0				;Get L result of multiplication
		add r0,r6				;Add Y offset
		
		
		mov #7,r1				;Move 7 pixels right (work right->left)
		add r1,r6				
		
		mov #8,r1				;Y Lines
NextYLine:	
		mov #8,r0				;Bits per line
		mov.b @r5+,r3			;Get a byte
NextXPixel:
		mov #1,r2				;Fill pixel
		
		rotcr r3				;Get a bit
		bt CharPixelSet
		mov #0,r2				;Clear pixel
CharPixelSet:		
		mov.b r2,@r6			;Write pixel
		add #-1,r6				;Left one pixel
		dt r0					;Decrease X count
		bf NextXPixel			;Repeat for next pixel
		
		mov.l #512+8,r0			;One line = 512 bytes + 8 pixels drawn
		add r0,r6				;Down a line
		dt r1					;Decrease Y count
		bf NextYLine			;Repeat for next line
				
		mov.l @(UserRam_CursorX,r4),r0
		add #1,r0				;Across one char
		mov.l r0,@(UserRam_CursorX,r4)
		
		
	mov.l @sp+,r6				;Restore the registers.
	mov.l @sp+,r5
	mov.l @sp+,r4
	mov.l @sp+,r3
	mov.l @sp+,r2
	mov.l @sp+,r1
	mov.l @sp+,r0
	lds.l @sp+,macl
	lds.l @sp+,mach
	rts							;Return from subroutine
	nop							;NOP in delay slot of RTS
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	
	ltorg						;Literal org, our inline defs go here!
	
Palette: ;-BBBBBGGGGGRRRRR
	dc.w %0011110000000000		;Our 4 colors!
	dc.w %0000001111111111
	dc.w %0111111111100000
	dc.w %0000000000011111
	
	
TxtHelloWorld: dc.b "Hello World 12345 !?",255	;255=End of string

Font:	binclude "\ResALL\Font96.FNT"	;1bpp font - 8x8 96 characters 

	align 4						;Ensure we're still 32 bit aligned!

UserRam_CursorX equ 0
UserRam_CursorY equ 4
UserRam:	ds.l 8				;Define 8 32bit longs 



