
	org $06000000
	
;Cpu 2 Entry - $06000000 - Secondary SH2 Exec address
Cpu2Loop:					;CPU2=Slave CPU CPU1=Master CPU
	bra	Cpu2Loop
	nop		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
				
;Cpu 1 Entry - $06000004 - Primary SH2 Exec address
Cpu1_ProgStart:				
	mov.l #$20004000,r2		;$20004000 	Interrupt mask	%F-----ACH---VHCP
							;  F=Vdp access (0=MD 1=SH2) A=Adapter enable (1=32x on) 
							;  C=Cart in?(1=no) H=H-int(1=on) C=Command int on
							;  P=PWM timer interrupt
Waitfor68k:
	mov.w @r2,r1			;MSH2_WW_IntC		Bus Controller
	exts.w r1,r1
	cmp/pz r1				;Bit 15=1 means SH2 has VDP
	bt Waitfor68k

;Turn on the screen
	
	mov.l #$20004100,r1	;$20004100  Bitmap Mode Register
	mov	#1,r2			;  %P-------pL----MM  P=Pal/Ntcs p+priorty(1=32x)
						;  L=240 line?  M=screen mode (pixel format)
	mov.w r2,@r1		;    Packed pixel Mode (8bpp palette)
	
;Define line tablee
	
	bsr DoLineTable			;Define Line table 1
	nop
	bsr PageFlip			;Flip Buffer
	nop
	bsr DoLineTable			;Define Line table 2
	nop
	
;Set up our palette	
	
	mov.l #$20004200,r6		;$20004200 - VDP CRAM (512 bytes)
	mov.l #Palette,r8		;Palette
	mov	#4,r0				;PaletteEntries
PaletteLoop:
	mov.w @r8+,r1			;-BBBBBGGGGGRRRRR
	mov.w r1,@r6			;Set a color
	add	#2,r6
	
	dt r0					;Dec R0
	bf PaletteLoop 
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Start 68000 program for joy read

	mov.l #$20004020,r1		;Shared Regs with 68000
	mov #0,r0
	mov.w r0,@(4,r1)		;Shut chibisound up!
	
	mov.l #$66606601,r0
	mov.l r0,@(0,r1)		;tell 68000 to start program 1
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
	
	mov.l #ChibikoBmp,r13		
	mov.l #48,r11			;Width
	mov.l #48,r10			;Height
	bsr ShowSpriteXY		;Show initial sprite
	nop
	
	bsr PageFlip			;Update screen buffer
	nop
	
InfLoop:	
	mov.l #$20004020,r10 	;Shared Regs Joy
	mov.w @r10,r0			;Get Joystick Directions ->R0
		
	mov #%00001111,r1		;%----RLDU
	and r1,r0
	cmp/eq r1,r0			;Any direction presssed?
	bt InfLoop
		
	
	mov.l #UserRam,r9	
	mov.l @(UserRam_PlayerX,r9),r1
	mov.l @(UserRam_PlayerY,r9),r2
	
	tst #%00000001,r0		;Up?
	bf JoyNotUp	
	mov.l #0,r3			
	cmp/eq r3,r2			;At top of screen?
	bt JoyNotUp
	add #-1,r2				;Move up
JoyNotUp:

	tst #%00000010,r0		;Dowm?
	bf JoyNotDown	
	mov.l #224-48,r3	
	cmp/eq r3,r2			;At bottom of screen?
	bt JoyNotDown
	add #1,r2				;Move down
JoyNotDown:

	tst #%00000100,r0		;Left?
	bf JoyNotLeft	
	mov.l #0,r3
	cmp/eq r3,r1			;At left of screen?
	bt JoyNotLeft		
	add #-1,r1				;Move left
JoyNotLeft:

	tst #%00001000,r0		;Right?
	bf JoyNotRight
	mov.l #320-48,r3
	cmp/eq r3,r1			;At right of screen?
	bt JoyNotRight
	add #1,r1				;Move right
JoyNotRight:
	
	mov.l r1,@(UserRam_PlayerX,r9)	;Store new sprite position
	mov.l r2,@(UserRam_PlayerY,r9)

	bsr Cls
	nop
	
	mov.l #ChibikoBmp,r13		
	mov.l #48,r11			;Width
	mov.l #48,r10			;Height
	bsr ShowSpriteXY		;Show new sprite
	nop
	
	bsr PageFlip			;Update screen buffer
	nop
	
	bra InfLoop
	nop

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


Cls:
	mov.l #$24000200,r6		;Screen VRAM
	mov.l #320*224/4,r0		;32 bit long count
	mov.l #0,r1				;Color to fill	
ClsLoop:
	mov.l r1,@r6	;Write 2 pixels
	add #4,r6		;Right 2 pixel
			
	dt r0
	bf ClsLoop
	rts
	nop
	
	
ShowSpriteXY: 	;R11=Wid R10=Hei
	mov.l #UserRam,r9		;R14 points to our work ram

	mov.l #$24000200,r12 	;Cache through Addr (Data) Screen VRAM	
						
	mov.l @(UserRam_PlayerX,r9),r0	;+Xpos
	add r0,r12
				
	mov.l @(UserRam_PlayerY,r9),r0	;+Ypos*320
	mov.l #320,r1	;320 bytes per line
	mulu r0,r1
	sts macl,r0		;Get L result of multiplication
	add r0,r12		;Add Y offset
		
		
ShowSprite:		;Show sprite @R13 to @R12
				;R11=Wid R10=Hei
				
	mov.l #320,r3		;Line Width in bytes
ShowSpriteY:
	mov r11,r1			;R11=Width
	mov r12,r2
ShowSpriteX:
		mov.l @r13+,r0		;Get a source word
		mov.l r0,@r12		;Store back to screen
		add #4,r12			;Across screen 4 pixels
		
		add #-3,r1			;We did 4 pixels
		dt r1				;We did 4 pixels
		bf ShowSpriteX		;Repeat
		
	mov r2,r12			;Reset Ypos
	add r3,r12			;Down a line
	
	dt r10				;R10=Height
	bf ShowSpriteY
	rts
	nop
	
	
	
	
DoLineTable:	
	mov.l #$24000000,r6   ; 11  - Ofst:&60001B4	Frame Buffer (128k bytes)- Cache through Addr (Line Table)
	mov.l #$100,r8	 	;LineStartAddr - Addr in pairs of bytes (Actual addr /2)
						; $[2400]0200/2=$100
	mov.l #224,r0 		;Line Count
	mov.l #160,r7		;Length of line in pairs of bytes (320/2)

LineTableLoop:	
	mov.w r8,@r6	;Define line address
	add r7,r8		;Move down one line
	add	#2,r6		;Next Line table address
	
	add #-1,r0
	cmp/eq #0,r0
	bf LineTableLoop
	rts	
	nop
	

PageFlip:
	mov.l #UserRam,r14		;R14 points to our work ram
	;mov.l AdrUserRam,r14		;R14 points to our work ram
	
	mov.l @(UserRam_VdpStat,r14),r1		;Get framebuffer state (Delay slot)
	mov	r1,r0
	mov.l #$2000410a,r2		;2000410a VDP State
	xor	#1,r0				;Flip frame buffer
	mov.l r0,@(UserRam_VdpStat,r14)	;Save in ram
	mov.w r0,@r2			;Flip frame buffer
	
WaitForFlip:	
	mov.l #$2000410a,r3	;2000410a VDP State
	mov.w @r3,r0
	and	#1,r0				;Buffer State
	cmp/eq r1,r0			;Has buffer flipped?
	bt WaitForFlip			;NO! Then Wait!!!
	rts	
	nop
	
	
	align 4	
	ltorg
	align 4

Palette:
	     
	dc.w %0000000000000000; ;0  %-BBBBBGGGGGRRRRR
    dc.w %0111110000010000; ;1  %-BBBBBGGGGGRRRRR
    dc.w %0111111111100000; ;2  %-BBBBBGGGGGRRRRR
    dc.w %0111111111111111; ;3  %-BBBBBGGGGGRRRRR
    dc.w %0010000100001000; ;4  %-BBBBBGGGGGRRRRR
    dc.w %0010100101001010; ;5  %-BBBBBGGGGGRRRRR
    dc.w %0011000110001100; ;6  %-BBBBBGGGGGRRRRR
    dc.w %0011100111001110; ;7  %-BBBBBGGGGGRRRRR
    dc.w %0100001000010000; ;8  %-BBBBBGGGGGRRRRR
    dc.w %0100101001010010; ;9  %-BBBBBGGGGGRRRRR
    dc.w %0101001010010100; ;10  %-BBBBBGGGGGRRRRR
    dc.w %0101101011010110; ;11  %-BBBBBGGGGGRRRRR
    dc.w %0110001100011000; ;12  %-BBBBBGGGGGRRRRR
    dc.w %0110101101011010; ;13  %-BBBBBGGGGGRRRRR
    dc.w %0111001110011100; ;14  %-BBBBBGGGGGRRRRR
    dc.w %0111101111011110; ;15  %-BBBBBGGGGGRRRRR

	

UserRam_VdpStat equ 0
UserRam_PlayerX equ 12
UserRam_PlayerY equ 16
	
UserRam:	dc.l 0	;VDP Stat cache
			dc.l 0	;Cursor Xpos
			dc.l 0	;Cusrso Ypos
			dc.l 0	;Player X
			dc.l 0	;Player Y
			dc.l 0

ChibikoBmp:		;1 byte per pixel - same as DOS VGA format
	binclude "\ResAll\Sprites\SpriteTestVGA.RAW"
		
	