

	org $6004000 		;Base address for a BIN file
	
	
;Set up the VDP2 registers
	mov.l #$25f80000,r11	;VDP2_Regs
	add #$E,r11				
		  ;%C-cc--VVRRRRRRRR cc=0=5bit RGB
	mov.w #%1000001111111111,r6 ;Set ram partitioning / screen mode
	mov.w r6,@r11		;$25f8000E RAMCTL - Ram Control Register

	add #$2e,r11		
		;%-NNN-nnn-NNN-nnn
	mov	#%0000000000000000,r2		
	mov.w r2,@r11		;$25f8003C MPOFN - Map Offset Register
	
	add #$3c,r11	
		;%NNNNNNNN--------
	mov.w r2,@-r11		;$25f80076 - SCYDN0 Scr Scroll (Vert Fraction)
	
		;%-----NNNNNNNNNNN
	mov.w r2,@-r11		;$25f80074 - SCYIN0 Scr Scroll (Vert Integer)
	
		;%NNNNNNNN--------
	mov.w r2,@-r11		;$25f80072 - SCXDN0 Scr Scroll (Horiz Fraction)
	
		;%-----NNNNNNNNNNN
	mov.w r2,@-r11		;$25f80070 - SCXIN0 Scr Scroll (Horiz Integer)
	
	add #-72,r11		
	      ;%--CCNNES-cccnnes c=colors (16/256/2k/32k/16m)  e=1=bmp format
	mov.w #%0000000000010010,r2	;nn=bmp size(512x256/512x512/1024x256/1024x512)
	mov.w r2,@r11		;$25f80028 CHCTLA - Character ctrl (NBG0, NBG1)
	
	 
	add	#-8,r11	
		  ;%---RNNNN--rrnnnn RN=Transparency / rn=enabled
	mov.w #%0000000100000001,r8
	mov.w r8,@r11		;$25f80020 BGON - Screen Display Enable
	
	add	#-32,r11	
		 ; %D------BLLVV-HHH	D=1=Screen on B=1=Blackout 
	mov.l #%1000000000000000,r10	;L=interlace H=Hres V=Vres
	mov.w r10,@r11		;$25f80000 TVMD - TV Mode
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;Set Palette
	mov.l #$25F00000,r6		;VDP2_CRAM
	mov.l #Palette,r8		;Palette
	mov	#4,r0				;PaletteEntries
PaletteLoop:
	mov.w @r8+,r1			;-BBBBBGGGGGRRRRR
	mov.w r1,@r6			;Set a color
	add	#2,r6
	
	dt r0					;Dec R0
	bf PaletteLoop 
	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		

	mov.l #ChibikoBmp,r13		
	mov.l #48,r11			;Width
	mov.l #48,r10			;Height
	bsr ShowSpriteXY		;Show initial sprite
	nop
	
InfLoop:	
	bsr GetJoy				;Get Joy into R0
	nop
		
	mov #%00001111,r1		;%----RLDU
	and r1,r0
	cmp/eq r1,r0			;Any direction presssed?
	bt InfLoop
		
		
	mov.l #UserRam,r9	
	mov.l @(UserRam_PlayerX,r9),r1
	mov.l @(UserRam_PlayerY,r9),r2
	
	tst #%00000001,r0		;Up?
	bf JoyNotUp	
	mov.l #0,r3			
	cmp/eq r3,r2			;At top of screen?
	bt JoyNotUp
	add #-1,r2				;Move up
JoyNotUp:

	tst #%00000010,r0		;Dowm?
	bf JoyNotDown	
	mov.l #224-48,r3	
	cmp/eq r3,r2			;At bottom of screen?
	bt JoyNotDown
	add #1,r2				;Move down
JoyNotDown:

	tst #%00000100,r0		;Left?
	bf JoyNotLeft	
	mov.l #0,r3
	cmp/eq r3,r1			;At left of screen?
	bt JoyNotLeft		
	add #-1,r1				;Move left
JoyNotLeft:

	tst #%00001000,r0		;Right?
	bf JoyNotRight
	mov.l #320-48,r3
	cmp/eq r3,r1			;At right of screen?
	bt JoyNotRight
	add #1,r1				;Move right
JoyNotRight:


	mov.l r1,@-sp
	mov.l r2,@-sp
		mov.l #ChibikoBmp,r13		
		mov.l #48,r11			;Width 
		mov.l #48,r10			;Height
		bsr ShowSpriteXY		;Remove old Sprite
		nop
	mov.l @sp+,r2
	mov.l @sp+,r1
	
	
	mov.l r1,@(UserRam_PlayerX,r9)	;Store new sprite position
	mov.l r2,@(UserRam_PlayerY,r9)

	mov.l #ChibikoBmp,r13		
	mov.l #48,r11			;Width
	mov.l #48,r10			;Height
	bsr ShowSpriteXY		;Show new sprite
	nop

	mov #$3FFFF,r0			;Crude delay loop
DelayLoop:	
	dt r0
	bf DelayLoop
	
	bra	InfLoop				;Branch to INFLOOP
	nop						;NOP in the BRA delay slot

	
;See: ST-169-R1-072694 System Manager & Peripheral control
; 	  PG 21+


;Set PDR1
;Set DDR13
;Set IOSEL1 to 1
;If latch required set EXLE to 1

GetJoy:
	sts.l pr,@-sp
	
;Set up the ports
		mov #%00000000,r0	;All ports to input 
		mov #$20100079,r1 ;DDR1	Data Dir %-DDDDDDD 1=output 0=input
		mov.b r0,@r1
		
		mov #0,r0			;0=SMPC / 1=SH2 direct
		mov #$2010007D,r1 ;% - - - - - - IOSEL2 IOSEL1 
		mov.b r0,@r1
	
		mov #0,r0			;1=VDP Latch
		mov #$2010007F,r1 ;% - - - - - - EXLE2 EXLE1
		mov.b r0,@r1
		
;Send our command
		mov.b #1,r0				;Flag busy before our command
		mov #$20100063,r13		;Status flag
		mov.b r0,@r13
		
		mov #$20100001,r1		;SMPC Status Acquisition Switch
		mov #$00,r0				;1=Get extra info (time reset etc)
		mov.b r0,@r1
		
		mov #$20100003,r1	
			; BBbbP-O-		bb/BB=15/255/?/0 bytes... P=peripheral data
		mov #%00001000,r0		;O=Acquisition Time Optimization
		mov.b r0,@r1			;GetPeriheral data  15 byte
			
		mov #$20100005,r1
		mov #$F0,r0				;Fixed value
		mov.b r0,@r1
			
		mov #$2010001F,r1		;Command
		mov #$10,r0				;INTBACK - Interrupt Back
		mov.b r0,@r1			; (SMPC Status Acquisition)

;Wait for results

GetJoyWait:
		mov #$20100063,r13	;Status flag
		mov.b @r13,r0
		and #1,r0			;Only bottom bit is defined
		cmp/eq #1,r0		;Wait for command completion
		bt GetJoyWait


		
;First byte =multitap ID (F=none)	
;Second byte = ${Devtype}{bytes} 0=Standard pad 2=2 bytes
;%11110001	= No multitap
;%00000010 	= Standard pad
;%RLDUSABC 	= Genesis buttons
;%rXYZl---  = Saturn buttons
		
;Shift the bits into our standard format.	
		
		mov #$20100020,r13
		
		mov.b @(5,r13),r0	;%RLDUSABC
		shlr2 r0
		shlr2 r0			;Get %----RLDU
		and #%00001111,r0
		mov r0,r1
		
		
		mov.b @(5,r13),r0	;%RLDUSABC
		shll2 r0
		shll2 r0			;Get %SABC----
		and #%11110000,r0
		or r1,r0
		mov r0,r1			;Now we have %SABCRLDU
		
		mov.b @(7,r13),r0	;%rXYZl---
		shll2 r0
		shll2 r0			
		shll r0				;Get %---rXYZl --------
		mov #%0001111100000000,r2
		and r2,r0			
		or r1,r0
		mov r0,r1			;Now we have %rXYZlSABCRLDU
				
		mov #$FFFFE000,r2	;Fill unused bits
		or r2,r0
			
	lds.l @sp+,pr		;Joy state in r0 %rXYZlSABCRLDU
	rts
	nop	
	
	

ShowSpriteXY: 	;R11=Wid R10=Hei
	mov.l #UserRam,r9		;R14 points to our work ram

	mov.l #$25e00000,r12 	;Cache through Addr (Data) Screen VRAM	
						
	mov.l @(UserRam_PlayerX,r9),r0	;+Xpos
	add r0,r12
				
	mov.l @(UserRam_PlayerY,r9),r0	;+Ypos*512
	mov.l #512,r1	;512 bytes per line
	mulu r0,r1
	sts macl,r0		;Get L result of multiplication
	add r0,r12		;Add Y offset
		
		
ShowSprite:		;Show sprite @R13 to @R12
				;R11=Wid R10=Hei
				
	mov.l #512,r3		;Line Width in bytes
ShowSpriteY:
	mov r11,r1			;R11=Width
	mov r12,r2
ShowSpriteX:
		mov.l @r13+,r0		;Get a source word
		mov.l @r12,r4		;Get screen word
		xor r4,r0			;XOR with current screen data
		mov.l r0,@r12		;Store back to screen
		add #4,r12			;Across screen 4 pixels
		
		add #-3,r1			;We did 4 pixels
		dt r1				;We did 4 pixels
		bf ShowSpriteX		;Repeat
		
	mov r2,r12			;Reset Ypos
	add r3,r12			;Down a line
	
	dt r10				;R10=Height
	bf ShowSpriteY
	rts
	nop
		
	align 4	
	ltorg


	
	
Palette:
	dc.w %0000000000000000; ;0  %-BBBBBGGGGGRRRRR
    dc.w %0111110000010000; ;1  %-BBBBBGGGGGRRRRR
    dc.w %0111111111100000; ;2  %-BBBBBGGGGGRRRRR
    dc.w %0111111111111111; ;3  %-BBBBBGGGGGRRRRR
    dc.w %0010000100001000; ;4  %-BBBBBGGGGGRRRRR
    dc.w %0010100101001010; ;5  %-BBBBBGGGGGRRRRR
    dc.w %0011000110001100; ;6  %-BBBBBGGGGGRRRRR
    dc.w %0011100111001110; ;7  %-BBBBBGGGGGRRRRR
    dc.w %0100001000010000; ;8  %-BBBBBGGGGGRRRRR
    dc.w %0100101001010010; ;9  %-BBBBBGGGGGRRRRR
    dc.w %0101001010010100; ;10  %-BBBBBGGGGGRRRRR
    dc.w %0101101011010110; ;11  %-BBBBBGGGGGRRRRR
    dc.w %0110001100011000; ;12  %-BBBBBGGGGGRRRRR
    dc.w %0110101101011010; ;13  %-BBBBBGGGGGRRRRR
    dc.w %0111001110011100; ;14  %-BBBBBGGGGGRRRRR
    dc.w %0111101111011110; ;15  %-BBBBBGGGGGRRRRR

	
		align 4

UserRam_VdpStat equ 0	
UserRam_PlayerX equ 12
UserRam_PlayerY equ 16	

UserRam:	dc.l 0	;VDP Stat cache
			dc.l 0	;Cursor Xpos
			dc.l 0	;Cusrso Ypos
			dc.l 0	;Player X
			dc.l 0	;Player Y
			dc.l 0

ChibikoBmp:		;1 byte per pixel - same as DOS VGA format
	binclude "\ResAll\Sprites\SpriteTestVGA.RAW"
		
	